<template>
  <el-dialog :append-to-body="true" :close-on-click-modal="false" :before-close="cancel" :visible.sync="dialog" :title="isAdd ? '新增' : '编辑'" width="500px">
    <el-form ref="form" :model="form" :rules="rules" size="small" label-width="80px">
      <el-form-item label="代码" prop="code">
        <el-input v-model.trim="form.code" style="width: 370px;"/>
      </el-form-item>
      <el-form-item label="名称" prop="subject">
        <el-input v-model.trim="form.subject" style="width: 370px;"/>
      </el-form-item>
      <el-form-item label="计算公式" prop="gs">
        <el-input v-model.trim="form.gs" style="width: 370px;"/>
      </el-form-item>
      <!--<el-form-item label="是否有效" >
        <el-input v-model="form.valid" style="width: 370px;"/>
      </el-form-item>
      <el-form-item label="创建时间" >
        <el-input v-model="form.createTime" style="width: 370px;"/>
      </el-form-item>
      <el-form-item label="更新时间" >
        <el-input v-model="form.updateTime" style="width: 370px;"/>
      </el-form-item>-->
      <el-form-item label="单位" >
        <el-input v-model.trim="form.unit" style="width: 370px;"/>
      </el-form-item>
    </el-form>
    <div slot="footer" class="dialog-footer">
      <el-button type="text" @click="cancel">取消</el-button>
      <el-button :loading="loading" type="primary" @click="doSubmit">确认</el-button>
    </div>
  </el-dialog>
</template>

<script>
import { add, edit } from '@/api/sItem'
export default {
  props: {
    isAdd: {
      type: Boolean,
      required: true
    }
  },
  data() {
    return {
      loading: false, dialog: false,
      form: {
        id: '',
        code: '',
        subject: '',
        gs: '',
        valid: '',
        createTime: '',
        updateTime: '',
        unit: ''
      },
      rules: {
        code: [
          { required: true, message: '请输入检测项代码', trigger: 'blur' }
        ],
        subject: [
          { required: true, message: '请输入检测项名称', trigger: 'blur' }
        ],
        gs: [
          { required: true, message: '请输入检测项公式', trigger: 'blur' }
        ]
      }
    }
  },
  methods: {
    cancel() {
      this.resetForm()
    },
    doSubmit() {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          this.loading = true
          if (this.isAdd) {
            this.doAdd()
          } else this.doEdit()
        } else {
          return false
        }
      })
    },
    doAdd() {
      add(this.form).then(res => {
        this.resetForm()
        this.$notify({
          title: '添加成功',
          type: 'success',
          duration: 2500
        })
        this.loading = false
        this.$parent.init()
      }).catch(err => {
        this.loading = false
        console.log(err.response.data.message)
      })
    },
    doEdit() {
      edit(this.form).then(res => {
        this.resetForm()
        this.$notify({
          title: '修改成功',
          type: 'success',
          duration: 2500
        })
        this.loading = false
        this.$parent.init()
      }).catch(err => {
        this.loading = false
        console.log(err.response.data.message)
      })
    },
    resetForm() {
      this.dialog = false
      this.$refs['form'].resetFields()
      this.form = {
        id: '',
        code: '',
        subject: '',
        gs: '',
        valid: '',
        createTime: '',
        updateTime: '',
        unit: ''
      }
    }
  }
}
</script>

<style scoped>

</style>
